
#------------------------------------------------------------------------------
# Project 'microgrid_10' make using the 'gnu' compiler.
#------------------------------------------------------------------------------

#------------------------------------------------------------------------------
# All project
#------------------------------------------------------------------------------

all: targets
	@echo !--Make: succeeded.



#------------------------------------------------------------------------------
# Directories, Architecture, and Version
#------------------------------------------------------------------------------

Arch        = windows
EmtdcDir    = C:\PROGRA~2\PSCAD4~1\emtdc\gnu
EmtdcInc    = $(EmtdcDir)\inc
EmtdcBin    = $(EmtdcDir)\$(Arch)
EmtdcMain   = $(EmtdcBin)\main.obj
EmtdcLib    = $(EmtdcBin)\emtdc.lib


#------------------------------------------------------------------------------
# Fortran Compiler
#------------------------------------------------------------------------------

FC_Name     = f2c.exe
FC_Suffix   = o
FC_Args     = -r8 -w -Nn5000 -NL400 -Nx400
FC_Debug    =  -g
FC_Warn     = 
FC_Checks   = 
FC_Includes = -I"$(EmtdcInc)" -I"$(EmtdcBin)"
FC_Compile  = $(FC_Name) $(FC_Args) $(FC_Includes) $(FC_Debug) $(FC_Warn) $(FC_Checks)

#------------------------------------------------------------------------------
# C Compiler
#------------------------------------------------------------------------------

CC_Name     = gcc.exe
CC_Suffix   = o
CC_Args     = -c
CC_Debug    =  -O
CC_Includes = -I"$(EmtdcInc)" -I"$(EmtdcBin)"
CC_Compile  = $(CC_Name) $(CC_Args) $(CC_Includes) $(CC_Debug)

#------------------------------------------------------------------------------
# Linker
#------------------------------------------------------------------------------

Link_Name   = gcc.exe
Link_Debug  = 
Link_Args   = -o $@
Link        = $(Link_Name) $(Link_Args) $(Link_Debug)

#------------------------------------------------------------------------------
# Build rules for PSCAD generated files
#------------------------------------------------------------------------------


%.$(FC_Suffix): %.f
	@echo !--Compile: $<
	$(FC_Compile) $<
	$(CC_Compile) $*.c
	del $*.c


%.$(CC_Suffix): %.c
	@echo !--Compile: $<
	$(CC_Compile) $<



#------------------------------------------------------------------------------
# Build rules for file references
#------------------------------------------------------------------------------


MYPV_R~1.$(FC_Suffix): C:\Users\ABC\Desktop\MICROG~1\MYPV_R~1.F
	@echo !--Compile: C:\Users\ABC\Desktop\MICROG~1\MYPV_R~1.F
	copy C:\Users\ABC\Desktop\MICROG~1\MYPV_R~1.F .
	$(FC_Compile) MYPV_R~1.f
	$(CC_Compile) MYPV_R~1.c
	del MYPV_R~1.f
	del MYPV_R~1.c

my_PSS.$(FC_Suffix): C:\Users\ABC\Desktop\MICROG~1\my_PSS.f
	@echo !--Compile: C:\Users\ABC\Desktop\MICROG~1\my_PSS.f
	copy C:\Users\ABC\Desktop\MICROG~1\my_PSS.f .
	$(FC_Compile) my_PSS.f
	$(CC_Compile) my_PSS.c
	del my_PSS.f
	del my_PSS.c

#------------------------------------------------------------------------------
# Dependencies
#------------------------------------------------------------------------------


FC_Objects = \
 Main.$(FC_Suffix) \
 Untitled_5.$(FC_Suffix) \
 DC_AC_1.$(FC_Suffix) \
 DEF_Load.$(FC_Suffix) \
 Untitled_2.$(FC_Suffix) \
 Untitled_1_1.$(FC_Suffix) \
 DC_AC.$(FC_Suffix) \
 Untitled_1.$(FC_Suffix) \
 Untitled_3.$(FC_Suffix) \
 microturbine.$(FC_Suffix) \
 AC_DC.$(FC_Suffix) \
 DC_AC_2.$(FC_Suffix) \
 DEF_Load_1.$(FC_Suffix) \
 DEF_Load_2.$(FC_Suffix) \
 MYPV_R~1.$(FC_Suffix) \
 my_PSS.$(FC_Suffix)

CC_Objects =

UserLibs =

SysLibs  = $(EmtdcBin)\libwsock32.a $(EmtdcBin)\libf2c.lib

Binary   = microgrid_10.exe

$(Binary): $(FC_Objects) $(CC_Objects) $(UserLibs)
	@echo !--Link: $@
	$(Link) "$(EmtdcMain)" *.$(CC_Suffix) $(UserLibs) "$(EmtdcLib)" $(SysLibs)

targets: $(Binary)


clean:
	-del EMTDC_V*
	-del *.obj
	-del *.o
	-del *.exe
	@echo !--Make clean: succeeded.



