!=======================================================================
! Generated by  : PSCAD v4.2.1
!
! Warning:  The content of this file is automatically generated.
!           Do not modify, as any changes made here will be lost!
!-----------------------------------------------------------------------
! Component     : microturbine
! Description   : microturbine generation system
!-----------------------------------------------------------------------


!=======================================================================

      SUBROUTINE microturbineDyn()

!---------------------------------------
! Standard includes
!---------------------------------------

      INCLUDE 'nd.h'
      INCLUDE 'emtconst.h'
      INCLUDE 'emtstor.h'
      INCLUDE 's0.h'
      INCLUDE 's1.h'
      INCLUDE 's2.h'
      INCLUDE 's4.h'
      INCLUDE 'branches.h'
      INCLUDE 'pscadv3.h'
      INCLUDE 'fnames.h'
      INCLUDE 'radiolinks.h'
      INCLUDE 'matlab.h'

!---------------------------------------
! Function/Subroutine Declarations
!---------------------------------------

      REAL    LDLGPOLE      ! Lead-Lag Function
      REAL    REALPOLE      ! Real Pole
      REAL    EMTDC_XPI     ! 'Proportional-Integral Controller /w Interpolation'
      REAL    LIMIT         ! Hard Limiter
      REAL    EMTDC_XINT    ! 'Integrator /w Interpolation'
!     SUBR    PMMACHINE     ! Permanent Magnet Machine
      REAL    DELAY         ! Delay Line
      REAL    DERIV1        ! Derivative Function
!     SUBR    TSAT21        ! Transformer Saturation Subroutine

!---------------------------------------
! Variable Declarations
!---------------------------------------


! Subroutine Parameters

! Electrical Node Indexes
      INTEGER NT_1(3), NT_2(3), NT_3

! Control Signals
      REAL    RT_1, RT_2, RT_3, RT_4, RT_5, RT_6
      REAL    RT_7, RT_8, RT_9, RT_10, Temp
      REAL    RT_11, Tm, Te2, w, Wf, Te, Pout
      REAL    Qout, RT_12, RT_13, RT_14, RT_15
      REAL    RT_16, RT_17, RT_18, RT_19, RT_20
      REAL    RT_21, RT_22, RT_23

! Internal Variables
      REAL    RVD2_1(2), RVD2_2(2), X_KNEE
      REAL    TURNS_V

! Indexing variables
      INTEGER ISTOF, IT_0                         ! Storage Indexes
      INTEGER IPGB                                ! Control/Monitoring
      INTEGER ISUBS, SS(1), IBRCH(1), INODE       ! SS/Node/Branch/Xfmr
      INTEGER IXFMR


!---------------------------------------
! Record local indexes
!---------------------------------------

! Dsdyn <-> Dsout transfer index storage
      NTXFR = NTXFR + 1
      TXFR(NTXFR,1) = NSTOL
      TXFR(NTXFR,2) = NSTOI
      TXFR(NTXFR,3) = NSTOF

! Record Offset and Increment Storage Counters
      ISTOF     = NSTOF
      NSTOF     = NSTOF + 31
      IPGB      = NPGB
      NPGB      = NPGB + 7
      INODE     = NNODE + 2
      NNODE     = NNODE + 12
      IXFMR     = NXFMR
      NXFMR     = NXFMR + 3

! Initialize Subsystem Mapping

      ISUBS = NSUBS + 0
      NSUBS = NSUBS + 1

      DO 100  IT_0 = 1,1
         SS(IT_0) = SUBS(ISUBS + IT_0)
  100 CONTINUE

! Initialize Branch Mapping.

      IBRCH(1)     = NBRCH(SS(1))
      NBRCH(SS(1)) = NBRCH(SS(1)) + 7

!---------------------------------------
! Transfers from storage arrays
!---------------------------------------

      RT_1     = STOF(ISTOF + 1)
      RT_2     = STOF(ISTOF + 2)
      RT_3     = STOF(ISTOF + 3)
      RT_4     = STOF(ISTOF + 4)
      RT_5     = STOF(ISTOF + 5)
      RT_6     = STOF(ISTOF + 6)
      RT_7     = STOF(ISTOF + 7)
      RT_8     = STOF(ISTOF + 8)
      RT_9     = STOF(ISTOF + 9)
      RT_10    = STOF(ISTOF + 10)
      Temp     = STOF(ISTOF + 11)
      RT_11    = STOF(ISTOF + 12)
      Tm       = STOF(ISTOF + 13)
      Te2      = STOF(ISTOF + 14)
      w        = STOF(ISTOF + 15)
      Wf       = STOF(ISTOF + 16)
      Te       = STOF(ISTOF + 17)
      Pout     = STOF(ISTOF + 18)
      Qout     = STOF(ISTOF + 19)
      RT_12    = STOF(ISTOF + 20)
      RT_13    = STOF(ISTOF + 21)
      RT_14    = STOF(ISTOF + 22)
      RT_15    = STOF(ISTOF + 23)
      RT_16    = STOF(ISTOF + 24)
      RT_17    = STOF(ISTOF + 25)
      RT_18    = STOF(ISTOF + 26)
      RT_19    = STOF(ISTOF + 27)
      RT_20    = STOF(ISTOF + 28)
      RT_21    = STOF(ISTOF + 29)
      RT_22    = STOF(ISTOF + 30)
      RT_23    = STOF(ISTOF + 31)

!---------------------------------------
! Transfer from Imports
!---------------------------------------


!---------------------------------------
! Electrical Node Lookup
!---------------------------------------

      NT_3  = NODE(INODE + 10)

! Array(1:3) quantities...
      DO 101  IT_0 = 1,3
         NT_1(IT_0) = NODE(INODE + 0 + IT_0)
         NT_2(IT_0) = NODE(INODE + 3 + IT_0)
  101 CONTINUE

!---------------------------------------
! Read Model data (if any)
!---------------------------------------

      IF ( TIMEZERO ) THEN
         FILENAME = 'microturbine.dta'
         CALL EMTDC_OPENFILE
         SECTION = 'DATADSD:'
         CALL EMTDC_GOTOSECTION
      ENDIF

!---------------------------------------
! Generated code from module definition
!---------------------------------------


! 10:[const] Real Constant 
      RT_4 = 950.0

! 20:[const] Real Constant 
      RT_9 = 0.23

! 30:[const] Real Constant 
      RT_1 = 1.0

! 40:[const] Real Constant 
      RT_8 = 0.01

! 80:[leadlag] Lead-Lag 
!  Lead_Lag
      RT_5 = LDLGPOLE(0,1,0,12.0,15.0,1.0,Temp,0.0,-10.0,10.0)

! 90:[realpole] Real Pole 
!  Real_Pole
      RT_13 = REALPOLE(0,1,0,1.0,2.5,RT_5,0.0,-10.0,10.0)

! 100:[sumjct] Summing/Differencing Junctions 
      RT_3 = - RT_13 + RT_4
!

! 110:[pi_ctlr] PI Controller \w Interpolation 
      RVD2_1(1) = RT_3
      RVD2_1(2) = 0.0
      RT_6 = EMTDC_XPI(0,0.0073,450.0,-1.0,1.0,0.0,RVD2_1)

! 120:[maxmin] Maximum/Minimum Functions 
      RT_14 = AMIN1(RT_6,RT_2,RT_7)
!

! 130:[hardlimit] Hard Limiter 
!  Hard_Limit
      RT_18 = LIMIT(-10.0, 10.0, RT_14)
!

! 140:[gain] Gain Block 
!  Gain
      Te2 = -1.0 * Te
!

! 150:[sumjct] Summing/Differencing Junctions 
      RT_23 = + Tm - Te2
!

! 160:[integral] Interpolated Integrator 
      RVD2_1(1) = RT_23
      RVD2_1(2) = 0.0
      RVD2_2(1) = 0.0
      RVD2_2(2) = 0.0
!
      w = EMTDC_XINT(0, 0, 0, 1.0, 15.64, 0.0,-100.0, 100.0,RVD2_2,RVD2_&
     &1)

! 170:[torque_function]  
        Tm=1.3*(RT_11-0.23)+0.5*(1-w)

! 180:[pm_machine] Permanent Magnet Synchronous Machine 
      CALL PMMACHINE(SS(1),NT_1, (IBRCH(1)+1), (IBRCH(1)+2), (IBRCH(1)+3&
     &),w,Te)

! 190:[mult] Multiplier 
!
      RT_17 = RT_18 * w
!

! 200:[gain] Gain Block 
!  Gain
      RT_19 = 0.77 * RT_17
!

! 210:[sumjct] Summing/Differencing Junctions 
      RT_20 = + RT_19 + RT_9
!

! 220:[realpole] Real Pole 
!  Real_Pole
      RT_21 = REALPOLE(0,1,0,1.0,0.05,RT_20,0.0,-10.0,10.0)

! 230:[realpole] Real Pole 
!  Real_Pole
      RT_22 = REALPOLE(0,1,0,1.0,0.4,RT_21,0.0,-10.0,10.0)

! 240:[tdelay] Delay Function 
!  Delay
      Wf = DELAY(0.01, 100, RT_22)
!

! 250:[realpole] Real Pole 
!  Real_Pole
      RT_11 = REALPOLE(0,1,0,1.0,0.2,Wf,0.0,-10.0,10.0)

! 260:[derivative] Derivative with a time constant 
!  Derivative
      RT_16 = DERIV1( 1.0 , w )
!

! 270:[sumjct] Summing/Differencing Junctions 
      RT_15 = - RT_16 + RT_8
!

! 280:[integral] Interpolated Integrator 
      RVD2_1(1) = RT_15
      RVD2_1(2) = 0.0
      RVD2_2(1) = 0.0
      RVD2_2(2) = 0.0
!
      RT_7 = EMTDC_XINT(0, 0, 0, 0.0, 0.01, 0.0,-100.0, 100.0,RVD2_2,RVD&
     &2_1)

! 290:[sumjct] Summing/Differencing Junctions 
      RT_12 = + RT_1 - w
!

! 300:[leadlag] Lead-Lag 
!  Lead_Lag
      RT_2 = LDLGPOLE(0,1,0,0.4,0.05,25.0,RT_12,0.0,-10.0,10.0)

! 310:[tdelay] Delay Function 
!  Delay
      RT_10 = DELAY(0.04, 100, Wf)
!

! 320:[temp_function]  
        Temp=950-700*(1-RT_10)+550*(1-w)

! 330:[pgb] Output Channel 'Te2'

      PGB(IPGB+3) = Te2

! 340:[pgb] Output Channel 'Tm'

      PGB(IPGB+4) = Tm

! 350:[pgb] Output Channel 'w'

      PGB(IPGB+5) = w

! 360:[pgb] Output Channel 'Wf'

      PGB(IPGB+6) = Wf

! 370:[pgb] Output Channel 'Temp'

      PGB(IPGB+7) = Temp

! -1:[xfmr-3p2w] 3 Phase 2 Winding Transformer 
!  TRANSFORMER SATURATION SUBROUTINE
      IF (TIME.GT.0.1) THEN
         X_KNEE = 1.25
      ELSE
         X_KNEE = -1.25
      ENDIF
      TURNS_V = 0.219393102292
      CALL TSAT21(NT_2(1),NT_3, NT_2(2),NT_3, NT_2(3),NT_3,SS(1),0.33333&
     &3333333,TURNS_V,0.2,X_KNEE,60.0,1.0,0.02, 0.0, 0)
!

!---------------------------------------
! Feedbacks and transfers to storage
!---------------------------------------

      STOF(ISTOF + 1) = RT_1
      STOF(ISTOF + 2) = RT_2
      STOF(ISTOF + 3) = RT_3
      STOF(ISTOF + 4) = RT_4
      STOF(ISTOF + 5) = RT_5
      STOF(ISTOF + 6) = RT_6
      STOF(ISTOF + 7) = RT_7
      STOF(ISTOF + 8) = RT_8
      STOF(ISTOF + 9) = RT_9
      STOF(ISTOF + 10) = RT_10
      STOF(ISTOF + 11) = Temp
      STOF(ISTOF + 12) = RT_11
      STOF(ISTOF + 13) = Tm
      STOF(ISTOF + 14) = Te2
      STOF(ISTOF + 15) = w
      STOF(ISTOF + 16) = Wf
      STOF(ISTOF + 17) = Te
      STOF(ISTOF + 18) = Pout
      STOF(ISTOF + 19) = Qout
      STOF(ISTOF + 20) = RT_12
      STOF(ISTOF + 21) = RT_13
      STOF(ISTOF + 22) = RT_14
      STOF(ISTOF + 23) = RT_15
      STOF(ISTOF + 24) = RT_16
      STOF(ISTOF + 25) = RT_17
      STOF(ISTOF + 26) = RT_18
      STOF(ISTOF + 27) = RT_19
      STOF(ISTOF + 28) = RT_20
      STOF(ISTOF + 29) = RT_21
      STOF(ISTOF + 30) = RT_22
      STOF(ISTOF + 31) = RT_23

!---------------------------------------
! Transfer to Exports
!---------------------------------------

!---------------------------------------
! Close Model Data read
!---------------------------------------

      IF ( TIMEZERO ) CALL EMTDC_CLOSEFILE
      RETURN
      END

!=======================================================================

      SUBROUTINE microturbineOut()

!---------------------------------------
! Standard includes
!---------------------------------------

      INCLUDE 'nd.h'
      INCLUDE 'emtconst.h'
      INCLUDE 'emtstor.h'
      INCLUDE 's0.h'
      INCLUDE 's1.h'
      INCLUDE 's2.h'
      INCLUDE 's4.h'
      INCLUDE 'branches.h'
      INCLUDE 'pscadv3.h'
      INCLUDE 'fnames.h'
      INCLUDE 'radiolinks.h'
      INCLUDE 'matlab.h'

!---------------------------------------
! Function/Subroutine Declarations
!---------------------------------------

      REAL    P3PH3         ! 
      REAL    Q3PH3         ! 

!---------------------------------------
! Variable Declarations
!---------------------------------------


! Electrical Node Indexes

! Control Signals
      REAL    Pout, Qout

! Internal Variables
      REAL    RVD1_1

! Indexing variables
      INTEGER ISTOL, ISTOI, ISTOF, IT_0           ! Storage Indexes
      INTEGER IPGB                                ! Control/Monitoring
      INTEGER ISUBS, SS(1), IBRCH(1), INODE       ! SS/Node/Branch/Xfmr
      INTEGER IXFMR


!---------------------------------------
! Record local indexes
!---------------------------------------

! Dsdyn <-> Dsout transfer index storage
      NTXFR = NTXFR + 1
      ISTOL = TXFR(NTXFR,1)
      ISTOI = TXFR(NTXFR,2)
      ISTOF = TXFR(NTXFR,3)

! Record Offset and Increment Storage Counters
      IPGB      = NPGB
      NPGB      = NPGB + 7
      INODE     = NNODE + 2
      NNODE     = NNODE + 12
      IXFMR     = NXFMR
      NXFMR     = NXFMR + 3

! Initialize Subsystem Mapping

      ISUBS = NSUBS + 0
      NSUBS = NSUBS + 1

      DO 100  IT_0 = 1,1
         SS(IT_0) = SUBS(ISUBS + IT_0)
  100 CONTINUE

! Initialize Branch Mapping.

      IBRCH(1)     = NBRCH(SS(1))
      NBRCH(SS(1)) = NBRCH(SS(1)) + 7

!---------------------------------------
! Transfers from storage arrays
!---------------------------------------

      Pout     = STOF(ISTOF + 18)
      Qout     = STOF(ISTOF + 19)

!---------------------------------------
! Electrical Node Lookup
!---------------------------------------


!---------------------------------------
! Read Model data (if any)
!---------------------------------------

      IF ( TIMEZERO ) THEN
         FILENAME = 'microturbine.dta'
         CALL EMTDC_OPENFILE
         SECTION = 'DATADSO:'
         CALL EMTDC_GOTOSECTION
      ENDIF

!---------------------------------------
! Generated code from module definition
!---------------------------------------


! 50:[multimeter] Multimeter 
!
!
!
      RVD1_1 = 0.5 * P3PH3(SS(1), (IBRCH(1)+4), (IBRCH(1)+5), (IBRCH(1)+&
     &6),0.02,0)
      Pout = RVD1_1
!
      RVD1_1 = 0.5 * Q3PH3(SS(1), (IBRCH(1)+4), (IBRCH(1)+5), (IBRCH(1)+&
     &6),0.02,0)
      Qout = RVD1_1
!
!
!

! 60:[pgb] Output Channel 'Pout'

      PGB(IPGB+1) = Pout

! 70:[pgb] Output Channel 'Qout'

      PGB(IPGB+2) = Qout

!---------------------------------------
! Feedbacks and transfers to storage
!---------------------------------------

      STOF(ISTOF + 18) = Pout
      STOF(ISTOF + 19) = Qout

!---------------------------------------
! Close Model Data read
!---------------------------------------

      IF ( TIMEZERO ) CALL EMTDC_CLOSEFILE
      RETURN
      END

