! CALL myPV_RTDS($AA,$BB,$SS,$INS,$TMP)      
      SUBROUTINE myPV_RTDS(NA,NB,SSN,INS,TMP)

!------------------------------------------------------------
!   Include and Common Block Declarations
!------------------------------------------------------------
      INCLUDE 'nd.h'
      INCLUDE 's0.h'
      INCLUDE 's1.h'
      INCLUDE 's2.h'
      INCLUDE 's4.h'
      INCLUDE 's8.h'
      INCLUDE 'branches.h' 

!------------------------------------------------------------
!  Argument List:
!------------------------------------------------------------

      INTEGER SSN        
      INTEGER NA,NB
      REAL INS
      REAL TMP
      
!------------------------------------------------------------
!   Variable Declarations
!------------------------------------------------------------

      REAL q
      REAL K
      
      REAL refTEMP
      REAL Iscref
      REAL Vocref
      REAL nid
      REAL Jtmp
      REAL Gamma
      REAL Impref
      REAL Vmpref

      REAL GL
      
      INTEGER Nc
      INTEGER Np
      INTEGER Ns
     
      
!------------------------------------------------------------      
!   Matrix declaration
!------------------------------------------------------------      
      
      REAL DG0(2,2),GD(2,2)
      REAL DGN0(2,2)
      INTEGER NODES(2)
      INTEGER N,FLAG
      
!------------------------------------------------------------
!   Temporary Variable Declarations
!------------------------------------------------------------
      
      REAL tVsA
      
      REAL tIsAold
      REAL tVsAold
      REAL tVsAold2
      
      REAL tVt
      REAL tVtref
      REAL tEg
      REAL tEgref
      REAL tIoref
      REAL tIsc
      REAL tAt
      REAL tIo
      REAL tVoc
      REAL tRs
      REAL tIscA
      REAL tVocA
      REAL tRsA
      REAL tIsA
      REAL tIinj
      
      REAL tNc
      REAL tNp
      REAL tNs
      
      REAL C_inj
      
!------------------------------------------------------------
!   Constant Definitions
!------------------------------------------------------------
      
      q = 1.6e-19
      K = 1.38e-23
      
      refTEMP = 25.0
      Iscref = 3.35
      Vocref = 21.7
      nid = 1.5
      Jtmp = 0.065
      Gamma = 3
      Impref = 3.05
      Vmpref = 17.4
      
      Nc = 36
!      Np = 9
      Np = 20
!      Ns = 20
!      Ns = 30	
!      Ns = 40	
       Ns = 50		

!------------------------------------------------------------      
!   Zhang Yi invented the new numerical oscillation suppression method
!------------------------------------------------------------      
      GL = 1.0
      
      IF(TIME.LT.DELT) THEN
	 
	  IF(NA.NE.0) ENABCCIN(NA,SSN) = .TRUE.
	  IF(NB.NE.0) ENABCCIN(NB,SSN) = .TRUE.
	  
	  DG0(1,1) = 0
	  DG0(1,2) = GL
	  DG0(2,1) = GL
	  DG0(2,2) = 0
	 
	  STOR(NEXC+11) = DG0(1,1)
	  STOR(NEXC+12) = DG0(1,2)
	  STOR(NEXC+13) = DG0(2,1)
	  STOR(NEXC+14) = DG0(2,2)
	  
	  NODES(1) = NA
          NODES(2) = NB 
	 
          N = 2
	  FLAG = 1
	 
	  CALL CHANGEG(DG0,NODES,SSN,N,FLAG)
      
      ENDIF
      
      IF(TIME.EQ.DELT) THEN

	  GD(1,1) = GL
	  GD(1,2) = GL
	  GD(2,1) = GL
	  GD(2,2) = GL
	 
          DGN0(1,1) = GD(1,1)-STOR(NEXC+12)
          DGN0(1,2) = GD(1,2)-STOR(NEXC+12)
          DGN0(2,1) = GD(2,1)-STOR(NEXC+13)
          DGN0(2,2) = GD(2,2)-STOR(NEXC+13)

	  STOR(NEXC+11) = GD(1,1)
	  STOR(NEXC+12) = GD(1,2)
	  STOR(NEXC+13) = GD(2,1)
          STOR(NEXC+14) = GD(2,2)

	  N = 2
	  FLAG = 1
	  
	  CALL CHANGEG(DGN0,NODES,SSN,N,FLAG)
	
	ENDIF
	
! No need to dynamically change G matrix

!      IF(TIME.GT.DELT) THEN
!
!        GD(1,1) = GL
!	GD(1,2) = GL
!	GD(2,1) = GL
!	GD(2,2) = GL
!	  
!        DGN0(1,1) = GD(1,1)-STOR(NEXC+11)
!        DGN0(1,2) = GD(1,2)-STOR(NEXC+12)
!        DGN0(2,1) = GD(2,1)-STOR(NEXC+13)
!        DGN0(2,2) = GD(2,2)-STOR(NEXC+14)
!        
!	STOR(NEXC+11) = GD(1,1)
!	STOR(NEXC+12) = GD(1,2)
!	STOR(NEXC+13) = GD(2,1)
!        STOR(NEXC+14) = GD(2,2)
!	 
!	N = 2
!	FLAG = 1
!	  
!	CALL CHANGEG(DGN0,NODES,SSN,N,FLAG)
!      
!      ENDIF

!------------------------------------------------------------
!   Model Code
!------------------------------------------------------------
      
!------------------------------------------------------------
! Convert integer parameters into double
!------------------------------------------------------------
      
      tNc = DFLOAT(Nc)
      tNp = DFLOAT(Np)
      tNs = DFLOAT(Ns)
      
!------------------------------------------------------------
! Recall the previous timestep IsA value
!------------------------------------------------------------
      
      tIsAold = STOR(NEXC+1)
      
!------------------------------------------------------------
! Get the terminal voltage
!------------------------------------------------------------
      
      tVsA = VDC(NA,SSN) - VDC(NB,SSN)
      
      tVsA = tVsA * 1000.0
      
!------------------------------------------------------------
! Do the math
!------------------------------------------------------------

! Vt: Thermal junciton voltage 

      tVt 	= (((TMP + 273) * K) / q) * tNc
      
      tVtref 	= (((refTEMP + 273) * K) / q) * tNc
      
      tEg 	= 1.16 - 0.000702 * (TMP + 273) ** 2 / (TMP + 273 - 1108)
      tEgref 	= 1.16 - 0.000702 * (refTEMP + 273) ** 2 / (refTEMP + 273 - 1108)
      
      tIoref	= Iscref / (EXP(Vocref / (nid * tVtref)) - 1.0)
      tIsc	= Iscref * ( INS / 1000.0 ) + Jtmp / 100.0 * Iscref * (TMP - refTEMP)
      
      tAt	= tIoref / ((refTEMP + 273) ** Gamma * EXP( -tEgref * tNc / (nid * tVtref) ))

! tIo: Saturation current

      tIo	= tAt * (TMP + 273) ** Gamma * EXP( -tEg * tNc / (nid * tVt) )
      
      tVoc	= (nid * tVt) * LOG(tIsc / tIo + 1.0)
      
      tRs	= ((nid * tVtref) * LOG((Iscref - Impref) / tIoref + 1.0) -  Vmpref) / Impref
      
      tIscA	= tNp * tIsc
      tVocA	= tNs * tVoc
      tRsA	= tNs / tNp * tRs	 
      
      tIsA	= tIscA - tNp * tIo * (EXP((tVsA + tIsAold * tRsA) / (nid * tNs * tVt)) - 1.0)
      
      STOR(NEXC+1) = tIsA
      
      
!------------------------------------------------------------
! Current injection is in KA
!------------------------------------------------------------
      
! Compensating the injection 
      
      tIinj = tIsA + tVsA * GL
      
      C_inj = tIinj / 1000.0

      
!------------------------------------------------------------
! DIRECTION OF INJECTION
! EMTDC:
! OUTGOING DIRECTION IS -
! INCOMING DIRECTION IS +
! 
! RTDS:
! OUTGOING DIRECTION IS +
! INCOMING DIRECTION IS -
!------------------------------------------------------------
      
      IF(NA.NE.0) CCIN(NA,SSN) = CCIN(NA,SSN) + C_inj
      IF(NB.NE.0) CCIN(NB,SSN) = CCIN(NB,SSN) - C_inj
      
      NEXC = NEXC+30
	
	RETURN
      END


!------------------------------------------------------------
! This subroutine changes the values of the conducance matrix
!------------------------------------------------------------

      SUBROUTINE CHANGEG(DG,NDES,SSN,N,FLAG)
      INCLUDE 'nd.h'
      INCLUDE 's0.h'
      INCLUDE 's1.h'
      INCLUDE 's2.h'
      INCLUDE 's4.h'
      INCLUDE 'S8.h'  
      INCLUDE 'branches.h'
      INCLUDE 'fill.h'
      
!------------------------------------------------------------
! Parameters
!------------------------------------------------------------

      REAL DG(2,2)
      INTEGER NDES(2)
      INTEGER SSN,N,FLAG

!------------------------------------------------------------      
! Local variable
!------------------------------------------------------------

      INTEGER MIN_NODE
      INTEGER i,j
	
	IF (FLAG.EQ.1) THEN
	
	  DO 7 i=1,N,1 
	  DO 6 j=1,N,1
       
            GM(NDES(i),NDES(j),SSN)= GM(NDES(i),NDES(j),SSN)+DG(i,j)
            
6       CONTINUE
7       CONTINUE 

	ENDIF
	
	DO 10 i=1,N,1 
	DO 9  j=1,N,1	
 	      
 	      FILLED(NDES(i),NDES(j),SSN) = .TRUE.
 	      
9       CONTINUE
10      CONTINUE 
      
!------------------------------------------------------------      	
! Set MXINV to force matrix triangularizations...
!------------------------------------------------------------      

        MIN_NODE = MIN(NDES(1),NDES(2))
	MXINV(SSN)=MIN(MXINV(SSN),MIN_NODE)
         

      RETURN
      END