! CALL my_PSS($DUTY,$IA,$DUTY_INC,$NEW_DUTY,$MODE)      
! This subroutine takes Load Current & Duty Cycle and calculates the new Duty Cycle

      SUBROUTINE my_PSS(DUTY,IA,DUTY_INC,NEW_DUTY,MODE)

!------------------------------------------------------------
!   Include and Common Block Declarations
!------------------------------------------------------------
      INCLUDE 'nd.h'
      INCLUDE 's0.h'
      INCLUDE 's1.h'
      INCLUDE 's2.h'
      INCLUDE 's4.h'
      INCLUDE 's8.h'
      INCLUDE 'branches.h' 


!------------------------------------------------------------
!  Argument List:
!------------------------------------------------------------

      REAL DUTY
      REAL IA
      REAL DUTY_INC
      REAL NEW_DUTY
      INTEGER MODE
      
!------------------------------------------------------------
!   Parameter Declarations
!------------------------------------------------------------

      REAL  DUTY_ref
      REAL  mag
      REAL  startupTime
      
!------------------------------------------------------------
!   Variable Declarations
!------------------------------------------------------------

      REAL Ds
      REAL Is
      
      REAL dDs
      REAL dIs
      
      REAL oldTime
      REAL curTime
      REAL samplePeriod
      
      INTEGER NRUNAVG
      INTEGER NRUNMPPT
      
      REAL Davg
      REAL Dold
      REAL fTemp
      REAL fTemp2
	      
      INTEGER nTemp
      INTEGER nTemp2
      INTEGER nTemp3

	REAL tDold
      	REAL tPold

! Run MPPT every 50ms (i.e., after every 3 cycles) The Sampling time
      
      samplePeriod = 0.05
      
! MPPT starting up time is 0.5 Sec (Starting time)
 
      startupTime = 0.5
      
      ! STOR(NEXC+11)= ptr to current table location -> 17
	! STOR(NEXC+12)= ptr to last table location + 1 -> 27
	! STOR(NEXC+13)= ptr to first table location -> 17
	! STOR(NEXC+14)= average value -> 0.0
	! STOR(NEXC+15)= 1/num_pnts -> 0.1
	! STOR(NEXC+16)= output signal address -> Not Used
	! STOR(NEXC+17)= table(1) data...
	
      IF(TIME.LT.DELT) THEN

! Before simulation starts
        
        STOR(NEXC+11)= 17
        STOR(NEXC+12)= 27
        STOR(NEXC+13)= 17
        STOR(NEXC+14)= 0.0
        STOR(NEXC+15)= 0.1
        STOR(NEXC+16)= 0
        
        STOR(NEXC+17)= 0.0
        STOR(NEXC+18)= 0.0
        STOR(NEXC+19)= 0.0
        STOR(NEXC+20)= 0.0
        STOR(NEXC+21)= 0.0
        STOR(NEXC+22)= 0.0
        STOR(NEXC+23)= 0.0
        STOR(NEXC+24)= 0.0
        STOR(NEXC+25)= 0.0
        STOR(NEXC+26)= 0.0
      
      ELSE IF(TIME.LT.startupTime) THEN
            
            oldTime = STOR(NEXC+3)
            curTime = oldTime + DELT
      
            IF (curTime .GE. samplePeriod) THEN
                curTime = 0.0
            
! Moving average with last 10 values of Duty Ratio
                
                nTemp = STOR(NEXC+11)
                Dold = STOR(NEXC+nTemp)
                STOR(NEXC+nTemp) = DUTY
                
                nTemp2 = STOR(NEXC+12)
                nTemp3 = STOR(NEXC+13)
                
                nTemp = nTemp + 1
                
                IF (nTemp .GE. nTemp2) THEN
                    nTemp = nTemp3
                ENDIF
                
                STOR(NEXC+11) = nTemp
                
! STOR(NEXC+14): Moving average sum

                fTemp = STOR(NEXC+14)
                fTemp = fTemp - Dold
                fTemp = fTemp + DUTY
                STOR(NEXC+14) = fTemp
                
                fTemp2 = STOR(NEXC+15)
                
                Davg = fTemp2 * fTemp
            
                NEW_DUTY = Davg
                
            ENDIF
            
            STOR(NEXC+3) = curTime
            
            MODE = 0
            
!NRUNMPPT The Mode operation

            STOR(NEXC+6) = 0 
            
            NEXC = NEXC + 30
            RETURN
      
      ENDIF
      
      oldTime = STOR(NEXC+3)
      
      curTime = oldTime + DELT
      
      IF (curTime .GE. samplePeriod) THEN
            
            curTime = 0.0
            
            NRUNMPPT = STOR(NEXC+6)
            
            IF (NRUNMPPT .EQ. 0) THEN
                NRUNMPPT = 1
            ELSE
                NRUNMPPT = 2
            ENDIF
            
            STOR(NEXC+6) = NRUNMPPT
            
      ELSE
      	    NRUNMPPT = 0
      ENDIF
      
      STOR(NEXC+3) = curTime

! PV OUTPUT SENSORLESS METHOD

! Duty Ratio Increment 1.0%

      mag = DUTY_INC
      
      IF (NRUNMPPT .EQ. 1) THEN

! MPPT First shot
                        
        STOR(NEXC+1) = DUTY
        STOR(NEXC+2) = IA

      ENDIF
      
      IF (NRUNMPPT .EQ. 2) THEN
	      
	    tDold = STOR(NEXC+1)
            tPold = STOR(NEXC+2)
            
            Ds = DUTY
            Is = IA
            
            dDs = Ds - tDold
            dIs = Is - tPold
            
            STOR(NEXC+1) = Ds
            STOR(NEXC+2) = Is 
	      
	    DUTY_ref = NEW_DUTY 
	      
	      
	      IF ( dDs .GE. 0.0 ) THEN

 		IF ( dIs .GE. 0.0 ) THEN

			Dtmp = DUTY_ref + mag
        		MODE = 0

		ELSE

			Dtmp = DUTY_ref - mag
			MODE = 1

		ENDIF	     

	      ELSE

 		IF ( dIs .GE. 0.0 ) THEN

			Dtmp = DUTY_ref - mag
			MODE = 2

		ELSE

			Dtmp = DUTY_ref + mag
			MODE = 3

		ENDIF	     
	      
	      ENDIF
	      
	      NEW_DUTY  = Dtmp
      
      ENDIF
      
      NEXC = NEXC + 30
      
      RETURN
      END
